﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.ServiceBus.Description;
using Microsoft.ServiceBus;
using Microsoft.ServiceBus.Messaging;

namespace SBV2QueueDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            string issuer = "owner";
            //string key = "8FGogxsM5yqx1gXIoL73nbtmPZUSHZBakI632m4IIRQ=";
            string key = "DqyhUCB+Yy5JBfakL62AmCo3u9gkW9vOLCvOYuhE6gU=";
            //string serviceNamespace = "rickgaribay-lab";
            string serviceNamespace = "int6003-sbtest-0-6";
            const string acsHostName = "http://accesscontrol.aadint.windows-int.net";
            string queueName = "Orders";


            /*********************************
             *** Administrative Operations ***
             *********************************/

            // Create management credentials
           // SharedSecretCredential sharedSecretCreds = TransportClientCredentialBase.CreateSharedSecretCredential(issuer, key);

            NamespaceManagerSettings settings = new NamespaceManagerSettings();
            TokenProvider tokenProvider = settings.TokenProvider = TokenProvider.CreateSharedSecretTokenProvider(issuer,key);
           

            // Create namespace client

            NamespaceManager manager = new NamespaceManager(ServiceBusEnvironment.CreateServiceUri("sb", serviceNamespace, string.Empty), settings);

            //ServiceBusNamespaceClient namespaceClient = new ServiceBusNamespaceClient(ServiceBusEnvironment.CreateServiceUri("sb", serviceNamespace, string.Empty), sharedSecretCreds);

            var qs = manager.GetQueues();

            var result = from q in qs
                         where q.Path.Equals(queueName, StringComparison.OrdinalIgnoreCase)
                         select q;

            //namespaceClient.DeleteQueue("orders");

            // Delete if exists
            //try
            //{
            //    namespaceClient.DeleteQueue(queueName);
            //}
            //catch (Exception ex)
            //{
            //    Console.WriteLine(ex.Message);

            //}

            if (result.Count() == 0)
            {
                Console.WriteLine("Queue does not exist");

                // Create Queue

                Console.WriteLine("Creating Queue...");

                QueueDescription queue = manager.CreateQueue(queueName);
            }



            /**************************
             *** Runtime Operations ***
             **************************/

            // Create Queue Client

            MessagingFactorySettings messagingFactorySettings = new MessagingFactorySettings();
            messagingFactorySettings.TokenProvider = settings.TokenProvider = TokenProvider.CreateSharedSecretTokenProvider(issuer, key);
            MessagingFactory messagingFactory = MessagingFactory.Create(ServiceBusEnvironment.CreateServiceUri("sb", serviceNamespace, string.Empty), messagingFactorySettings);
            QueueClient queueClient = messagingFactory.CreateQueueClient(queueName, ReceiveMode.PeekLock);


            Order order = new Order();
            order.OrderId = 42;
            order.Products.Add("Kinect", 70.50M);
            order.Products.Add("XBOX 360", 199.99M);
            order.Total = order.Products["Kinect"] + order.Products["XBOX 360"];

            // Create a Brokered Message from the order object
            //var msg = BrokeredMessage.CreateMessage(order);
            BrokeredMessage msg = new BrokeredMessage(order);

            /***********************
            *** Send Operations  ***
            ************************/

            // Create Message Sender
            //var messageSender = queueClient();
            //messageSender.Send(msg);
            //messageSender.Close();

            queueClient.Send(msg);

            /**************************
             *** Receive Operations ***
           ****************************/

            // Receive with Peek Lock
            //var messageReceiver = queueClient.CreateReceiver(ReceiveMode.PeekLock);
            //var recdMsg = messageReceiver.Receive();
            //messageReceiver.Close();

            BrokeredMessage recdMsg = queueClient.Receive();
            

            Order recdOrder = recdMsg.GetBody<Order>();

            Console.WriteLine("Received Order {0} from {1} with total of ${2}", recdOrder.OrderId, "Receiver 1", recdOrder.Total);

            Console.WriteLine("Crash! Exception!");

            // Recieve again
            //messageReceiver = queueClient.CreateReceiver(ReceiveMode.PeekLock);
            

            try
            {
                //recdMsg = messageReceiver.Receive();
                //messageReceiver.Complete(recdMsg);
                //messageReceiver.Close();

               recdMsg = queueClient.Receive();
                recdOrder = recdMsg.GetBody<Order>();
                queueClient.Complete(recdMsg.LockToken);

                Console.WriteLine("Received Order {0} from {1} with total of ${2}", recdOrder.OrderId, "Receiver 2", recdOrder.Total);
            }
            catch
            {
                queueClient.Abandon(recdMsg.LockToken);
            }

            Console.WriteLine("Hit any key to exit.");
            Console.ReadLine();
        }
    }
}
