﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.ServiceBus.Description;
using Microsoft.ServiceBus;
using Microsoft.ServiceBus.Messaging;
using Microsoft.ServiceBus.Messaging.Filters;

namespace NetTopicSample
{
    class Program
    {
        static void Main(string[] args)
        {
            string issuer = "owner";
            string key = "DqyhUCB+Yy5JBfakL62AmCo3u9gkW9vOLCvOYuhE6gU=";
            //string key = "8FGogxsM5yqx1gXIoL73nbtmPZUSHZBakI632m4IIRQ=";
            //string serviceNamespace = "rickgaribay-lab";
            string serviceNamespace = "int6003-sbtest-0-6";
            const string acsHostName = "http://accesscontrol.aadint.windows-int.net";
            string topicName = "OrdersTopic";

            /*********************************
             *** Administrative Operations ***
             *********************************/

            // Create management credentials
            //SharedSecretCredential sharedSecretCreds = TransportClientCredentialBase.CreateSharedSecretCredential(issuer, key);

            // Create namespace client
            //ServiceBusNamespaceClient namespaceClient = new ServiceBusNamespaceClient(
            //        ServiceBusEnvironment.CreateServiceUri(
            //        "sb", serviceNamespace,
            //        string.Empty),
            //        sharedSecretCreds);

            NamespaceManagerSettings settings = new NamespaceManagerSettings();
            settings.TokenProvider = TokenProvider.CreateSharedSecretTokenProvider(issuer, key);
            NamespaceManager manager = new NamespaceManager(ServiceBusEnvironment.CreateServiceUri("sb", serviceNamespace, string.Empty), settings);

            //MessagingFactory messagingFactory = MessagingFactory.Create(
            //    ServiceBusEnvironment.CreateServiceUri(
            //    "sb",
            //    serviceNamespace,
            //    string.Empty),
            //                sharedSecretCreds);

            

            //var queues = namespaceClient.GetQueues();
            //foreach (var q in queues)
            //{
            //    if (q.Path == "orders")
            //    {
            //        namespaceClient.DeleteQueue("orders");
            //    }
            //}

            //var topics = namespaceClient.GetTopics();
            

            // NEW 
            //var topics = manager.GetTopics();
            //foreach (var t in topics)
            //{
            //    if (t.Path.Equals(topicName, StringComparison.OrdinalIgnoreCase))
            //    {
            //        //namespaceClient.DeleteTopic(topicName);
            //        manager.DeleteTopic(topicName);
            //    }
            //}

            //Topic ordersTopic = namespaceClient.CreateTopic(topicName);
            
            // NEW
            //TopicDescription ordersTopic = manager.CreateTopic(topicName);
         
            // Create Subscriptions

            //Subscription inventoryServiceSubscription = ordersTopic.AddSubscription("InventoryServiceSubscription");
            //Subscription creditServiceSubscription = ordersTopic.AddSubscription("CreditServiceSubscription");

            SubscriptionDescription inventoryServiceSubscription = new SubscriptionDescription { Name = "InventoryServiceSubscription", TopicPath = "OrdersTopic" };
            SubscriptionDescription creditServiceSubscription = new SubscriptionDescription { Name = "CreditServiceSubscription", TopicPath = "OrdersTopic" };

            // Set up Filters
            RuleDescription fulfillmentRuleDescription = new RuleDescription();
            fulfillmentRuleDescription.FilterExpression = new SqlFilterExpression("CountryOfOrigin = 'USA' OR CountryOfOrigin ='Canada' OR CountryOfOrgin ='Mexico'");
            fulfillmentRuleDescription.FilterAction = new SqlFilterAction("set FulfillmentRegion='North America'");

            RuleDescription asiaFulfillmentRuleDescription = new RuleDescription();
            asiaFulfillmentRuleDescription.FilterExpression = new SqlFilterExpression("CountryOfOrigin = 'Japan'");
            asiaFulfillmentRuleDescription.FilterAction = new SqlFilterAction("set FulfillmentRegion='Asia'");

            // Configure to support sessions/grouping as well as filter on USA orders
            // TODO: Determine if FilterActions can set standard properties on BrokerMessage and determine pros/cons of using Session/Grouped receiver versus Topic filter approach used here.
            //Subscription fulfillmentServiceSubscription = ordersTopic.AddSubscription("FulfillmentServiceSubscription", new SubscriptionDescription { RequiresSession = true },new SqlFilterExpression("FulfillmentRegion='USA'"));

            //Subscription fulfillmentServiceSubscription = ordersTopic.AddSubscription("FulfillmentServiceSubscription", new SubscriptionDescription { RequiresSession = true },new SqlFilterExpression("FulfillmentRegion='USA'"));

            //Subscription northAmericaFulfillmentServiceSubscription = ordersTopic.AddSubscription("NorthAmericaFulfillmentServiceSubscription", fulfillmentRuleDescription);
            SubscriptionDescription northAmericaFulfillmentServiceSubscription = new SubscriptionDescription { Name = "NorthAmericaFulfillmentServiceSubscription", TopicPath = "OrdersTopic" };
            //Subscription northAmericaFulfillmentServiceSubscription = ordersTopic.AddSubscription("FulfillmentServiceSubscription",new MatchNoneFilterExpression());
            //fulfillmentServiceSubscription.RemoveRule("$DefaultRule");
            //fulfillmentServiceSubscription.AddRule("North America", new RuleDescription { FilterExpression = new SqlFilterExpression("CountryOfOrgin = 'USA' OR CountryOfOrigin ='Canada' OR CountryOfOrgin ='Mexico'"), FilterAction = new SqlFilterAction("set FulfillmentRegion = 'North America'") });
            //fulfillmentServiceSubscription.AddRule("Asia",new RuleDescription{ FilterExpression = new SqlFilterExpression("CountryOfOrgin = 'Japan'"), FilterAction= new SqlFilterAction("set FulfillmentRegion = 'Asia'")});

            //Subscription asiaFulfillmentServiceSubscription = ordersTopic.AddSubscription("AsiaFulfillmentServiceSubscription", asiaFulfillmentRuleDescription);
            SubscriptionDescription asiaFulfillmentServiceSubscription = new SubscriptionDescription { Name = "AsiaFulfillmentServiceSubscription", TopicPath = "OrdersTopic" };
            //asiaFulfillmentServiceSubscription.AddRule("Asia", new RuleDescription { FilterExpression = new SqlFilterExpression("CountryOfOrgin = 'Japan'"), FilterAction = new SqlFilterAction("set FulfillmentRegion = 'Asia'") });



            /* OPTION */
            //fulfillmentServiceSubscription.AddRule("Foo", new SqlFilterExpression("CountryOfOrginin = 'Canada'"));

            /**************************
             *** Runtime Operations ***
             **************************/

                        //MessagingFactory messagingFactory = MessagingFactory.Create(
            //    ServiceBusEnvironment.CreateServiceUri(
            //    "sb",
            //    serviceNamespace,
            //    string.Empty),
            //                sharedSecretCreds);


            MessagingFactorySettings runtimeSettings = new MessagingFactorySettings();
            runtimeSettings.TokenProvider = TokenProvider.CreateSharedSecretTokenProvider(issuer, key);

            MessagingFactory messagingFactory = MessagingFactory.Create(ServiceBusEnvironment.CreateServiceUri("sb",serviceNamespace,String.Empty),runtimeSettings);
            
            //TopicClient pOSClientPublisher = messagingFactory.CreateTopicClient(topicName);
            TopicClient client = messagingFactory.CreateTopicClient("OrdersTopic");
         


            /***********************
             *** Send Operations ***
             ***********************/

             //MessageSender msgSender = pOSClientPublisher.CreateSender();

            Order order = new Order();
            order.OrderId = 42;
            order.Products.Add("Kinect", 70.50M);
            order.Products.Add("XBOX 360", 199.99M);
            order.Total = order.Products["Kinect"] + order.Products["XBOX 360"];

            //var msg = BrokeredMessage.CreateMessage(order);
            BrokeredMessage msg = new BrokeredMessage(order);

            // TODO: Determine if FilterActions can set standard properties on BrokerMessage and determine pros/cons of using Session/Grouped receiver versus Topic filter approach used here.
            //msg.SessionId = "Europe";

            msg.Properties.Add("CountryOfOrigin", "USA");
            msg.Properties.Add("FulfillmentRegion", "");

            //msgSender.Send(msg);
            //msgSender.Close();
            client.Send(msg);
            client.Close();
            


           /**************************
             *** Receive Operations ***
           ****************************/
            /*
             * Subcribe
             */

            // Inventory Service Subscriber

            SubscriptionClient inventoryServiceSubscriber = messagingFactory.CreateSubscriptionClient(topicName, "InventoryServiceSubscription",ReceiveMode.PeekLock);

            //MessageReceiver msgReceiver = inventoryServiceSubscriber.CreateReceiver(ReceiveMode.PeekLock);
            //var recdMsg = msgReceiver.Receive();
            //msgReceiver.Close();

            BrokeredMessage recdMsg;
            Order recdOrder;

            while ((recdMsg = inventoryServiceSubscriber.Receive(TimeSpan.FromSeconds(5))) != null)
            {
                inventoryServiceSubscriber.Close();

                recdOrder = recdMsg.GetBody<Order>();

                Console.ForegroundColor = ConsoleColor.Green;
                Console.WriteLine("Received Order {0} on {1}.", recdOrder.OrderId, "Inventory Service Subscriber");
            }

            // Credit Service Subscriber
            SubscriptionClient creditServiceSubscriber = messagingFactory.CreateSubscriptionClient(topicName, "CreditServiceSubscription");

            //msgReceiver = creditServiceSubscriber.CreateReceiver(ReceiveMode.PeekLock);

            //recdMsg = msgReceiver.Receive();
            //msgReceiver.Close();

            recdMsg = creditServiceSubscriber.Receive();
            creditServiceSubscriber.Close();

            recdOrder = recdMsg.GetBody<Order>();

            Console.ForegroundColor = ConsoleColor.Green;
            Console.WriteLine("Received Order {0} on {1}.", recdOrder.OrderId, "Credit Service Subscriber");

            // Fulfillment Service Subscriber

            SubscriptionClient fulfillmentServiceSubscriber = messagingFactory.CreateSubscriptionClient(topicName, "northAmericaFulfillmentServiceSubscription");

            // What does this do?
            //fulfillmentServiceSubscription.RemoveRule("North America");
            //fulfillmentServiceSubscription.RemoveRule("Asia");
            //fulfillmentServiceSubscriber.AddRule("NA", new SqlFilterExpression("FulfillmentRegion = 'North America'"));
            //fulfillmentServiceSubscriber.AddRule("COO", new SqlFilterExpression("CountryOfOrigin = 'Canada'"));


            /*Option/* 
             */
            //fulfillmentServiceSubscriber.AddRule("Foo", new SqlFilterExpression("CountryOfOrginin = 'Canada'"));

            //msgReceiver = fulfillmentServiceSubscriber.CreateReceiver(ReceiveMode.PeekLock);

            //MessageReceiver sessionedMsgReceiver = fulfillmentServiceSubscriber.AcceptSessionReceiver("North America", ReceiveMode.PeekLock);

            //msgReceiver = fulfillmentServiceSubscriber.CreateReceiver(ReceiveMode.PeekLock);

            //if (msgReceiver.TryReceive(new TimeSpan(0, 0, 5), out recdMsg))
            
            //{
            //    recdOrder = recdMsg.GetBody<Order>();

            //    Console.ForegroundColor = ConsoleColor.Green;
            //    Console.WriteLine("Received Order {0} on {1}.", recdOrder.OrderId, "North America Fulfillment Service Subscriber");

            //}
            //else
            //{
            //    Console.ForegroundColor = ConsoleColor.Red;
            //    Console.WriteLine("No messages for North America found");
            //}
            //msgReceiver.Close();


           recdMsg = fulfillmentServiceSubscriber.Receive();

            if(recdMsg != null)
            {
                Console.ForegroundColor = ConsoleColor.Green;
                Console.WriteLine("Received Order {0} on {1}.", recdOrder.OrderId, "North America Fulfillment Service Subscriber");
            }
            else
            {
                Console.ForegroundColor = ConsoleColor.Red;
                Console.WriteLine("No messages for North America found");
            }
            //msgReceiver.Close();


            fulfillmentServiceSubscriber = messagingFactory.CreateSubscriptionClient(topicName, "AsiaFulfillmentServiceSubscription");
            //msgReceiver = fulfillmentServiceSubscriber.CreateReceiver(ReceiveMode.ReceiveAndDelete);

            recdMsg = fulfillmentServiceSubscriber.Receive();
            if(recdMsg!=null)
            //if (msgReceiver.TryReceive(new TimeSpan(0, 0, 5), out recdMsg))
            {
                recdOrder = recdMsg.GetBody<Order>();

                Console.ForegroundColor = ConsoleColor.Green;
                Console.WriteLine("Received Order {0} on {1}.", recdOrder.OrderId, "Asia Fulfillment Service Subscriber");

            }
            else
            {
                Console.ForegroundColor = ConsoleColor.Red;
                Console.WriteLine("No messages for Asia found");
            }
            //msgReceiver.Close();
            fulfillmentServiceSubscriber.Close();

            Console.ReadLine();



        }
    }
}
